%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                                      %%
%%  FlexClock                                                           %%
%%                                                                      %%
%%  (c) 2000 Universit catholique de Louvain.  All Rights Reserved.    %%
%%  The development of this software is supported by the PIRATES        %%
%%  project at the Universit catholique de Louvain.  This file is      %%
%%  subject to the general Mozart license.                              %%
%%                                                                      %%
%%  Author: Donatien Grolaux                                            %%
%%                                                                      %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

functor

import
   Application
   QTk at 'x-oz://system/wp/QTk.ozf'
   OS

require IconFile
   
prepare IconLib=IconFile.buildLibrary

define

\define APP
   
   Lib={QTk.buildImageLibrary IconLib}
   
   Icons={List.map
	  [107#47 133#58 166#72 208#91 21#9 259#112
	   27#12 34#15 42#19 55#24 69#30 85#38]
	  fun{$ W#H}
	     r(width:W
	       height:H
	       name:{VirtualString.toAtom "mozart-"#W#"x"#H#".gif"})
	  end}
   
   proc{DrawIcon Canvas Tag X Y Radius}
      {Tag delete}
      _#IH#IName={List.foldR Icons
		  fun{$ R IW#IH#IName}
		     if R.width<Radius-5 andthen
			R.height<(Radius div 2) andthen
			R.width*R.height>IW*IH then
			R.width#R.height#R.name
		     else
			IW#IH#IName
		     end
		  end
		  0#0#unit}
   in
      if IName==unit then skip else
	 {Canvas create(image X Y+(Radius div 2) image:{Lib get(name:IName image:$)} tags:Tag)}
	 {Tag lower}
      end
   end
   
   \insert FlexClock.oz
   
   {Application.exit 0}
   
end
